// fogdlg.cpp : implementation file
//

#include "stdafx.h"
#include "test.h"
#include "fogdlg.h"
#include "amber.hpp"
#include "GL/gl.h"
#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

void changeFog(CFogDlg *dlg)
{
	channelClass *ch = amber->getCurrentChannel();

	ch->setFogFar(dlg->m_far);
	ch->setFogNear(dlg->m_near);
	ch->setFogDensity(dlg->m_density);
	if (dlg->m_linear)
		ch->setFogMode(GL_LINEAR);
	else if (dlg->m_exp)
		ch->setFogMode(GL_EXP);
	else
		ch->setFogMode(GL_EXP2);
}
/////////////////////////////////////////////////////////////////////////////
// CFogDlg dialog


CFogDlg::CFogDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFogDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFogDlg)
	m_exp = FALSE;
	m_exp2 = FALSE;
	m_linear = FALSE;
	m_density = 0.0f;
	m_far = 0.0f;
	m_near = 0.0f;
	m_on = FALSE;
	//}}AFX_DATA_INIT
	Create(ID_FOG_DLG);
}


void CFogDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFogDlg)
	DDX_Control(pDX, ID_FOG_DENSITY_UP, m_density_up);
	DDX_Control(pDX, ID_FOG_DENSITY_DN, m_density_dn);
	DDX_Control(pDX, ID_FOG_NEAR_UP, m_near_up);
	DDX_Control(pDX, ID_FOG_NEAR_DN, m_near_dn);
	DDX_Control(pDX, ID_FOG_FAR_UP, m_far_up);
	DDX_Control(pDX, ID_FOG_FAR_DN, m_far_dn);
	DDX_Check(pDX, ID_FOG_EXP, m_exp);
	DDX_Check(pDX, ID_FOG_EXP2, m_exp2);
	DDX_Check(pDX, ID_FOG_LINEAR, m_linear);
	DDX_Text(pDX, ID_FOG_DENSITY, m_density);
	DDX_Text(pDX, ID_FOG_FAR, m_far);
	DDX_Text(pDX, ID_FOG_NEAR, m_near);
	DDX_Check(pDX, ID_FOG_ON, m_on);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFogDlg, CDialog)
	//{{AFX_MSG_MAP(CFogDlg)
	ON_EN_CHANGE(ID_FOG_DENSITY, OnChangeFogDensity)
	ON_BN_CLICKED(ID_FOG_DENSITY_DN, OnFogDensityDn)
	ON_BN_CLICKED(ID_FOG_DENSITY_UP, OnFogDensityUp)
	ON_BN_CLICKED(ID_FOG_EXP, OnFogExp)
	ON_BN_CLICKED(ID_FOG_EXP2, OnFogExp2)
	ON_EN_CHANGE(ID_FOG_FAR, OnChangeFogFar)
	ON_BN_CLICKED(ID_FOG_FAR_DN, OnFogFarDn)
	ON_BN_CLICKED(ID_FOG_FAR_UP, OnFogFarUp)
	ON_BN_CLICKED(ID_FOG_LINEAR, OnFogLinear)
	ON_EN_CHANGE(ID_FOG_NEAR, OnChangeFogNear)
	ON_BN_CLICKED(ID_FOG_NEAR_DN, OnFogNearDn)
	ON_BN_CLICKED(ID_FOG_NEAR_UP, OnFogNearUp)
	ON_WM_SHOWWINDOW()
	ON_BN_CLICKED(ID_FOG_ON, OnFogOn)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CFogDlg message handlers

void CFogDlg::OnChangeFogDensity() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	changeFog(this);
	UpdateData(FALSE);
}

void CFogDlg::OnFogDensityDn() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_density -= 0.1;
	changeFog(this);
	UpdateData(FALSE);
}

void CFogDlg::OnFogDensityUp() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_density += 0.1;
	changeFog(this);
	UpdateData(FALSE);
}

void CFogDlg::OnFogExp() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_linear=0;
	m_exp2 = 0;
	changeFog(this);
	UpdateData(FALSE);	
}

void CFogDlg::OnFogExp2() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_exp = 0;
	m_linear = 0;
	changeFog(this);
	UpdateData(FALSE);	
}

void CFogDlg::OnChangeFogFar() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	changeFog(this);
	UpdateData(FALSE);	
}

void CFogDlg::OnFogFarDn() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_far -= 50.0;
	changeFog(this);
	UpdateData(FALSE);
}

void CFogDlg::OnFogFarUp() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_far += 50.0;
	changeFog(this);
	UpdateData(FALSE);
}

void CFogDlg::OnFogLinear() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_exp = 0;
	m_exp2 = 0;
	changeFog(this);
	UpdateData(FALSE);
}

void CFogDlg::OnChangeFogNear() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	changeFog(this);
	UpdateData(FALSE);	
}

void CFogDlg::OnFogNearDn() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_near -= 0.2;
	changeFog(this);
	UpdateData(FALSE);	
}

void CFogDlg::OnFogNearUp() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_near += 0.2;
	changeFog(this);
	UpdateData(FALSE);	
}

void CFogDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	// TODO: Add your message handler code here
	channelClass *ch = amber->getCurrentChannel();
	int mode;

	if (ch != NULL) {
		m_density = ch->getFogDensity();
		m_far     = ch->getFogFar();
		m_near    = ch->getFogNear();
		mode      = ch->getFogMode();
		if (mode == _LINEAR) {
			m_linear=1;
			m_exp=m_exp2=0;
		}
		else if (mode == _EXP) {
			m_exp=1;
			m_linear=m_exp2=0;
		}
		else {
			m_exp2=1;
			m_linear=m_exp2=0;
		}
		UpdateData(FALSE);
	}
}

void CFogDlg::OnFogOn() 
{
	// TODO: Add your control notification handler code here
	channelClass *ch = amber->getCurrentChannel();
	if (!ch) return;

	UpdateData(TRUE);
	if (m_on) 
		ch->enableState(RENDER_FOG);
	else
		ch->disableState(RENDER_FOG);
}
