// testview.h : interface of the CTestView class
//
/////////////////////////////////////////////////////////////////////////////
#include "channel.hpp"
#include "mouse.hpp"
#include "platter.hpp"

class CTestView : public CView
{
protected: // create from serialization only
	CTestView();
	DECLARE_DYNCREATE(CTestView)

// Attributes
public:
	CTestDoc* GetDocument();
	channelClass *ch;
	mouseClass *mouse;
	platterClass *platter;
	int useMouse;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTestView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual void OnInitialUpdate();
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CTestView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CTestView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLightControl();
	afx_msg void OnUpdateLightControl(CCmdUI* pCmdUI);
	afx_msg void OnRenderBbox();
	afx_msg void OnUpdateRenderBbox(CCmdUI* pCmdUI);
	afx_msg void OnRenderLines();
	afx_msg void OnUpdateRenderLines(CCmdUI* pCmdUI);
	afx_msg void OnRenderMaterial();
	afx_msg void OnUpdateRenderMaterial(CCmdUI* pCmdUI);
	afx_msg void OnRenderNormals();
	afx_msg void OnUpdateRenderNormals(CCmdUI* pCmdUI);
	afx_msg void OnRenderPerf();
	afx_msg void OnRenderPoints();
	afx_msg void OnUpdateRenderPoints(CCmdUI* pCmdUI);
	afx_msg void OnRenderPolys();
	afx_msg void OnUpdateRenderPolys(CCmdUI* pCmdUI);
	afx_msg void OnRenderTris();
	afx_msg void OnUpdateRenderTris(CCmdUI* pCmdUI);
	afx_msg void OnVpDeclin();
	afx_msg void OnVpDecrot();
	afx_msg void OnVpInclin();
	afx_msg void OnVpIncrot();
	afx_msg void OnRenderShading();
	afx_msg void OnUpdateRenderShading(CCmdUI* pCmdUI);
	afx_msg void OnUnivBkgcolor();
	afx_msg void OnVpClipping();
	afx_msg void OnVpMouse();
	afx_msg void OnUpdateVpMouse(CCmdUI* pCmdUI);
	afx_msg void OnVpPlatter();
	afx_msg void OnUpdateVpPlatter(CCmdUI* pCmdUI);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnVioRunning();
	afx_msg void OnUpdateVioRunning(CCmdUI* pCmdUI);
	afx_msg void OnFog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in testview.cpp
inline CTestDoc* CTestView::GetDocument()
   { return (CTestDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
