// lessovw.cpp : implementation of the CLesson1View class
//

#include "stdafx.h"
#include "lesson1.h"

#include "lessodoc.h"
#include "lessovw.h"

#include "amber.hpp"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

void myInit()
{
	cubeClass *cube;
	V3 pos;

	// Create a unit cube
	//
	cube = new cubeClass(1,1,1);

	// Set the cubes position 10 units
	// away from the viewpoint.
	//
	V3_set(pos, 0.0, 0.0, -10.0);
	cube->setPosition(pos);
	
	// Rotate the cube so that we can get
	// some perspective without moving
	//
	cube->rotate(1, 45*DEG_TO_RAD);
	cube->rotate(0, 20*DEG_TO_RAD);

}

/////////////////////////////////////////////////////////////////////////////
// CLesson1View

IMPLEMENT_DYNCREATE(CLesson1View, CView)

BEGIN_MESSAGE_MAP(CLesson1View, CView)
	//{{AFX_MSG_MAP(CLesson1View)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLesson1View construction/destruction

CLesson1View::CLesson1View()
{
	// TODO: add construction code here

	// Initialize Amber channel
	ch = NULL;

}

CLesson1View::~CLesson1View()
{
}

/////////////////////////////////////////////////////////////////////////////
// CLesson1View drawing

void CLesson1View::OnDraw(CDC* pDC)
{
	CLesson1Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CLesson1View printing

BOOL CLesson1View::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CLesson1View::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CLesson1View::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CLesson1View diagnostics

#ifdef _DEBUG
void CLesson1View::AssertValid() const
{
	CView::AssertValid();
}

void CLesson1View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CLesson1Doc* CLesson1View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CLesson1Doc)));
	return (CLesson1Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CLesson1View message handlers

void CLesson1View::OnInitialUpdate() 
{
	// TODO: Add your specialized code here and/or call the base class

	// Retrieve the HWND pointer to this window
	//
	HWND hwnd = GetSafeHwnd();

	// Create the channel if it has not already been created
	//
	if (ch == NULL) {
		ch = new channelClass((void *)hwnd);
		myInit();
	}

	CView::OnInitialUpdate();
}

void CLesson1View::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	
	// Adjust Amber channel when window size is changed.  Return if
	// channel has not been created or this window is not visible.
	//
	if (!IsWindowVisible() || ch==NULL) return;
	ch->resetPerspective();
}

BOOL CLesson1View::PreCreateWindow(CREATESTRUCT& cs) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	// Set the style of the window to clip children and siblings.  This
	// is a requirement of OpenGL windows.
	//	
	cs.style = cs.style | WS_CLIPSIBLINGS | WS_CLIPCHILDREN;

	return CView::PreCreateWindow(cs);
}
