// clipdlg.cpp : implementation file
//

#include "stdafx.h"
#include "test.h"
#include "clipdlg.h"
#include "amber.hpp"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CClipDlg dialog


CClipDlg::CClipDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CClipDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CClipDlg)
	m_far = 10.0;
	m_near = 1.0;
	m_angle = 1.0;
	//}}AFX_DATA_INIT
}


void CClipDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CClipDlg)
	DDX_Text(pDX, ID_UNIV_FARCLIP, m_far);
	DDV_MinMaxDouble(pDX, m_far, 1., 100000000.);
	DDX_Text(pDX, ID_UNIV_NEARCLIP, m_near);
	DDV_MinMaxDouble(pDX, m_near, 0., 100000000.);
	DDX_Text(pDX, ID_UNIV_VIEWANGLE, m_angle);
	DDV_MinMaxDouble(pDX, m_angle, 1., 180.);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CClipDlg, CDialog)
	//{{AFX_MSG_MAP(CClipDlg)
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CClipDlg message handlers

void CClipDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CClipDlg::OnOK() 
{
	// TODO: Add extra validation here
	channelClass *ch = amber->getCurrentChannel();
	UpdateData(TRUE);

	ch->setViewAngle(m_angle);
	ch->setPlanes(m_near, m_far);
		
	CDialog::OnOK();
}

BOOL CClipDlg::OnInitDialog() 
{
	channelClass *ch = amber->getCurrentChannel();
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	if (ch != NULL) {
		m_near = ch->getNearPlane();	
		m_far = ch->getFarPlane();
		m_angle = ch->getViewAngle();
		UpdateData(FALSE);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CClipDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	// TODO: Add your message handler code here
	channelClass *ch = amber->getCurrentChannel();
	if (ch != NULL) {
		m_near = ch->getNearPlane();	
		m_far = ch->getFarPlane();
		m_angle = ch->getViewAngle();
		UpdateData(FALSE);
	}
	
}
