// lightdlg.cpp : implementation file
//

#include "lightdlg.h"
#include "resource.h"
#include "amber.hpp"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

#define X 0
#define Y 1
#define Z 2
/////////////////////////////////////////////////////////////////////////////
// CLightDlg dialog

CLightDlg::CLightDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLightDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLightDlg)
	m_amb_a = 1.0f;
	m_amb_b = 0.1f;
	m_amb_g = 0.1f;
	m_amb_r = 0.1f;
	m_diff_a = 1.0f;
	m_diff_b = 1.0f;
	m_diff_g = 1.0f;
	m_diff_r = 1.0f;
	m_num = _T("LIGHT 0");
	m_pos_w = 0.0;
	m_pos_x = 0.0;
	m_pos_y = 0.0;
	m_pos_z = 0.0;
	m_spec_a = 1.0f;
	m_spec_b = 1.0f;
	m_spec_g = 1.0f;
	m_spec_r = 1.0f;
	m_cutoff = 180.0f;
	m_dir_x = 0.0f;
	m_dir_y = 0.0f;
	m_dir_z = 0.0f;
	m_spot = FALSE;
	m_on = FALSE;
	currentLight = 0;
	//}}AFX_DATA_INIT
	Create(IDD_LIGHT_DLG);

	//updateAttributes();
}


void CLightDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLightDlg)
	DDX_Text(pDX, ID_AMB_A, m_amb_a);
	DDV_MinMaxFloat(pDX, m_amb_a, 0.f, 1.f);
	DDX_Text(pDX, ID_AMB_B, m_amb_b);
	DDV_MinMaxFloat(pDX, m_amb_b, 0.f, 1.f);
	DDX_Text(pDX, ID_AMB_G, m_amb_g);
	DDV_MinMaxFloat(pDX, m_amb_g, 0.f, 1.f);
	DDX_Text(pDX, ID_AMB_R, m_amb_r);
	DDV_MinMaxFloat(pDX, m_amb_r, 0.f, 1.f);
	DDX_Text(pDX, ID_DIFF_A, m_diff_a);
	DDV_MinMaxFloat(pDX, m_diff_a, 0.f, 1.f);
	DDX_Text(pDX, ID_DIFF_B, m_diff_b);
	DDV_MinMaxFloat(pDX, m_diff_b, 0.f, 1.f);
	DDX_Text(pDX, ID_DIFF_G, m_diff_g);
	DDV_MinMaxFloat(pDX, m_diff_g, 0.f, 1.f);
	DDX_Text(pDX, ID_DIFF_R, m_diff_r);
	DDV_MinMaxFloat(pDX, m_diff_r, 0.f, 1.f);
	DDX_CBString(pDX, ID_LIGHT_NUM, m_num);
	DDX_Text(pDX, ID_POS_X, m_pos_x);
	DDX_Text(pDX, ID_POS_Y, m_pos_y);
	DDX_Text(pDX, ID_POS_Z, m_pos_z);
	DDX_Text(pDX, ID_SPEC_A, m_spec_a);
	DDV_MinMaxFloat(pDX, m_spec_a, 0.f, 1.f);
	DDX_Text(pDX, ID_SPEC_B, m_spec_b);
	DDV_MinMaxFloat(pDX, m_spec_b, 0.f, 1.f);
	DDX_Text(pDX, ID_SPEC_G, m_spec_g);
	DDV_MinMaxFloat(pDX, m_spec_g, 0.f, 1.f);
	DDX_Text(pDX, ID_SPEC_R, m_spec_r);
	DDV_MinMaxFloat(pDX, m_spec_r, 0.f, 1.f);
	DDX_Text(pDX, ID_CUTOFF, m_cutoff);
	DDV_MinMaxFloat(pDX, m_cutoff, 0.f, 180.f);
	DDX_Text(pDX, ID_DIR_X, m_dir_x);
	DDX_Text(pDX, ID_DIR_Y, m_dir_y);
	DDX_Text(pDX, ID_DIR_Z, m_dir_z);
	DDX_Check(pDX, ID_LIGHT_SPOT, m_spot);
	DDX_Check(pDX, ID_LIGHT_ON, m_on);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLightDlg, CDialog)
	//{{AFX_MSG_MAP(CLightDlg)
	ON_BN_CLICKED(ID_LIGHT_APPLY, OnLightApply)
	ON_BN_CLICKED(ID_LIGHT_DONE, OnLightDone)
	ON_CBN_SELCHANGE(ID_LIGHT_NUM, OnSelchangeLightNum)
	ON_BN_CLICKED(ID_LIGHT_SPOT, OnLightSpot)
	ON_WM_SHOWWINDOW()
	ON_BN_CLICKED(ID_LIGHT_ON, OnLightOn)
	ON_BN_CLICKED(ID_LIGHT_Flood, OnLIGHTFlood)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CLightDlg message handlers

void CLightDlg::OnLightApply() 
{
	// TODO: Add your control notification handler code here
	setAttributes();
}

void CLightDlg::setAttributes()
{
	universeClass *univ = amber->getCurrentUniverse();
	lightClass *light;
	F3 dir, pos;
	F4 ambient;
	CWnd   *edi[15];
	int i;
				  
	UpdateData(TRUE);

	edi[0] = GetDlgItem(ID_POS_X);
	edi[1] = GetDlgItem(ID_POS_Y);
	edi[2] = GetDlgItem(ID_POS_Z);
	edi[3] = GetDlgItem(ID_CUTOFF);
	edi[4] = GetDlgItem(ID_DIR_X);
	edi[5] = GetDlgItem(ID_DIR_Y);
	edi[6] = GetDlgItem(ID_DIR_Z);

	if (m_spot) {
		for (i=0; i<4; i++) edi[i]->EnableWindow(TRUE);
	}
	else {
		for (i=0; i<4; i++) edi[i]->EnableWindow(FALSE);
	}

	if (currentLight >= 0 && currentLight <= 7) {

		switch (currentLight) {
			case 0:
				light = univ->light0;
				break;
			case 1:
				light = univ->light1;
				break;
			case 2:
				light = univ->light2;
				break;
			case 3:
				light = univ->light3;
				break;
			case 4:
				light = univ->light4;
				break;
			case 5:
				light = univ->light5;
				break;
			case 6:
				light = univ->light6;
				break;
			case 7:
				light = univ->light7;
				break;
		}

		light->setState(m_on);
#ifdef AMBER_3DR
		light->setAmbient(m_amb_r, m_amb_g, m_amb_b);
		light->setDiffuse(m_diff_r, m_diff_g, m_diff_b);
		light->setSpecular(m_spec_r, m_spec_g, m_spec_b);
#endif
#ifdef AMBER_OPENGL
		light->setAmbient(m_amb_r, m_amb_g, m_amb_b, m_amb_a);
		light->setDiffuse(m_diff_r, m_diff_g, m_diff_b, m_diff_a);
		light->setSpecular(m_spec_r, m_spec_g, m_spec_b, m_spec_a);
#endif
		light->setSpot(m_spot);
		if (m_spot) {
			pos[0]=m_pos_x;
			pos[1]=m_pos_y;
			pos[2]=m_pos_z;
			light->setPosition(pos);
		}
		dir[0]=m_dir_x;
		dir[1]=m_dir_y;
		dir[2]=m_dir_z;
		light->setDirection(dir);
		light->setCutoff(m_cutoff);

	}
	else {
		F4_set(ambient, m_amb_r,  m_amb_g, m_amb_b, m_amb_a);
		univ->setAmbientLight(ambient);
	}
	
}

void CLightDlg::OnLightDone() 
{
	// TODO: Add your control notification handler code here
	ShowWindow(SW_HIDE);		
	
}

void CLightDlg::OnSelchangeLightNum() 
{
	// TODO: Add your control notification handler code here
	CComboBox *cb = (CComboBox *)GetDlgItem(ID_LIGHT_NUM);

	UpdateData(TRUE);

	currentLight = cb->GetCurSel();	
	cb->SetCurSel(currentLight);
	updateAttributes();

}

void CLightDlg::OnLightSpot() 
{
	// TODO: Add your control notification handler code here

	setAttributes();

}
void CLightDlg::updateAttributes()
{
	CWnd   *edi[15];
	int 	i;
	universeClass *univ = amber->getCurrentUniverse();
	CComboBox *cb = (CComboBox *)GetDlgItem(ID_LIGHT_NUM);
	lightClass *light;
	F4 amb;
#ifdef AMBER_OPENGL
	F4 vals;
#endif
#ifdef AMBER_3DR
	F3 vals;
#endif
	F3 pos, dir;

	edi[0] = GetDlgItem(ID_POS_X);
	edi[1] = GetDlgItem(ID_POS_Y);
	edi[2] = GetDlgItem(ID_POS_Z);
	edi[3] = GetDlgItem(ID_CUTOFF);
	edi[4] = GetDlgItem(ID_DIR_X);
	edi[5] = GetDlgItem(ID_DIR_Y);
	edi[6] = GetDlgItem(ID_DIR_Z);

	edi[7] = GetDlgItem(ID_DIFF_R);
	edi[8] = GetDlgItem(ID_DIFF_G);
	edi[9] = GetDlgItem(ID_DIFF_B);
	edi[10] = GetDlgItem(ID_DIFF_A);

	edi[11] = GetDlgItem(ID_SPEC_R);
	edi[12] = GetDlgItem(ID_SPEC_G);
	edi[13] = GetDlgItem(ID_SPEC_B);
	edi[14] = GetDlgItem(ID_SPEC_A);

	switch (currentLight) {
		case 0:
			light = univ->light0;
			break;
		case 1:
			light = univ->light1;
			break;
		case 2:
			light = univ->light2;
			break;
		case 3:
			light = univ->light3;
			break;
		case 4:
			light = univ->light4;
			break;
		case 5:
			light = univ->light5;
			break;
		case 6:
			light = univ->light6;
			break;
		case 7:
			light = univ->light7;
			break;
	}

	if (currentLight < 8) {
		m_on = light->getState();
		light->getAmbient(vals);
		m_amb_r=vals[0];
		m_amb_g=vals[1];
		m_amb_b=vals[2];
#ifdef AMBER_OPENGL
		m_amb_a=vals[3];
#endif
		light->getDiffuse(vals);
		m_diff_r=vals[0];
		m_diff_g=vals[1];
		m_diff_b=vals[2];
#ifdef AMBER_OPENGL
		m_diff_a=vals[3];
#endif
		light->getSpecular(vals);
		m_spec_r=vals[0];
		m_spec_g=vals[1];
		m_spec_b=vals[2];
#ifdef AMBER_OPENGL
		m_spec_a=vals[3];
#endif
		light->getPosition(pos);
		light->getDirection(dir);
		m_dir_x=dir[0];
		m_dir_y=dir[1];
		m_dir_z=dir[2];
		m_cutoff = light->getCutoff();
		m_spot   = light->getSpot();
		if (!m_spot) {
			m_pos_x=0.0;
			m_pos_y=0.0;
			m_pos_z=0.0;
		}
		else {
			m_pos_x=pos[0];
			m_pos_y=pos[1];
			m_pos_z=pos[2];
		}
		for (i=0; i<15; i++) edi[i]->EnableWindow(TRUE);
	}
	else {
		univ->getAmbientLight(amb);
		m_amb_r=vals[0];
		m_amb_g=vals[1];
		m_amb_b=vals[2];
		m_amb_a=vals[3];
		for (i=0; i<15; i++) edi[i]->EnableWindow(FALSE);
	}
	if (m_spot) {
		for (i=0; i<4; i++) edi[i]->EnableWindow(TRUE);
	}
	else {
		for (i=0; i<4; i++) edi[i]->EnableWindow(FALSE);
	}

	UpdateData(FALSE);
	cb->SetCurSel(currentLight);
}


void CLightDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	// TODO: Add your message handler code here
	currentLight = 0;
	updateAttributes();
	
}

void CLightDlg::OnLightOn() 
{
	// TODO: Add your control notification handler code here
	setAttributes();	
}

void CLightDlg::OnLIGHTFlood() 
{
	// TODO: Add your control notification handler code here
	universeClass *univ = amber->getCurrentUniverse();
 	F3 vals;
	vectorClass v;

	v.set(0.0, 0.0, 1.0);
	vals[0] = (float)v.v[0];
	vals[1] = (float)v.v[1];
	vals[2] = (float)v.v[2];
	univ->light0->setDirection(vals);
	univ->light0->setState(TRUE);
	v.rotate(Y, Pi/2.0);	
	vals[0] = (float)v.v[0];
	vals[1] = (float)v.v[1];
	vals[2] = (float)v.v[2];
	univ->light1->setDirection(vals);
	univ->light1->setState(TRUE);
	v.rotate(Y, Pi/2.0);	
	vals[0] = (float)v.v[0];
	vals[1] = (float)v.v[1];
	vals[2] = (float)v.v[2];
	univ->light2->setDirection(vals);
	univ->light2->setState(TRUE);
	v.rotate(Y, Pi/2.0);	
	vals[0] = (float)v.v[0];
	vals[1] = (float)v.v[1];
	vals[2] = (float)v.v[2];
	univ->light3->setDirection(vals);
	univ->light3->setState(TRUE);
	v.rotate(Z, Pi/2.0);	
	vals[0] = (float)v.v[0];
	vals[1] = (float)v.v[1];
	vals[2] = (float)v.v[2];
	univ->light4->setDirection(vals);
	univ->light4->setState(TRUE);
	v.rotate(Z, Pi);	
	vals[0] = (float)v.v[0];
	vals[1] = (float)v.v[1];
	vals[2] = (float)v.v[2];
	univ->light5->setDirection(vals);
	univ->light5->setState(TRUE);
	updateAttributes();

}
