// lessovw.cpp : implementation of the Clesson2View class
//

#include "stdafx.h"
#include "lesson2.h"

#include "lessodoc.h"
#include "lessovw.h"

#include "amber.hpp"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

void myInit(channelClass *ch)
{
	cubeClass *cube;
	V3 pos;
	F4 color = {0.0, 0.5, 0.5, 1.0};

	// Change the channel background color.
	//
	ch->setBackgroundColor(color);

	// Change the way in which polygons are rendered
	// to be unfilled.
	//
	//ch->setPolyFill(_NOFILL);

	// Create a unit cube
	//
	cube = new cubeClass(1,1,1);

	// Set the cubes position 10 units
	// away from the viewpoint.
	//
	V3_set(pos, 0.0, 0.0, -10.0);
	cube->setPosition(pos);
	
	// Rotate the cube so that we can get
	// some perspective without moving
	//
	cube->rotate(1, 45*DEG_TO_RAD);
	cube->rotate(0, 20*DEG_TO_RAD);

}


/////////////////////////////////////////////////////////////////////////////
// Clesson2View

IMPLEMENT_DYNCREATE(Clesson2View, CView)

BEGIN_MESSAGE_MAP(Clesson2View, CView)
	//{{AFX_MSG_MAP(Clesson2View)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Clesson2View construction/destruction

Clesson2View::Clesson2View()
{
	// TODO: add construction code here

	// Initialize Amber channel
	ch = NULL;

	// Initialize Amber mouse
	mouse = NULL;

}

Clesson2View::~Clesson2View()
{

	// Delete mouse
	delete mouse;
}

/////////////////////////////////////////////////////////////////////////////
// Clesson2View drawing

void Clesson2View::OnDraw(CDC* pDC)
{
	Clesson2Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// Clesson2View printing

BOOL Clesson2View::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void Clesson2View::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void Clesson2View::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// Clesson2View diagnostics

#ifdef _DEBUG
void Clesson2View::AssertValid() const
{
	CView::AssertValid();
}

void Clesson2View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

Clesson2Doc* Clesson2View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(Clesson2Doc)));
	return (Clesson2Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// Clesson2View message handlers

void Clesson2View::OnInitialUpdate() 
{
	// TODO: Add your specialized code here and/or call the base class

	// Retrieve the HWND pointer to this window
	//
	HWND hwnd = GetSafeHwnd();

	// Create the channel if it has not already been created
	//
	if (ch == NULL) {
		ch = new channelClass((void *)hwnd);
		myInit(ch);
	}

	// Create the mouse if it has not already been created
	// Also, attach the channel to the mouse.
	if (mouse == NULL) {
		mouse = new mouseClass(m_hWnd);
		//mouse->attachChannel(ch);
		cubeClass *g;
		V3 pos;
		F4 red = {1.0, 0.0, 0.0, 1.0};
		g = new cubeClass(0.25, 2.0, 0.25);
		V3_set(pos, 0.0, 0.0, -10.0);
		g->setPosition(pos);
		g->setAllColor(red);
		mouse->attachGeometry(g);

		// Constrain all linear motion
		//
		mouse->setPosConstraint(0);	
		mouse->setPosConstraint(1);	
		mouse->setPosConstraint(2);	
	
	}
	// Adjust the mouse sensors linear scaling 
	// to 10% the size of the universe every frame.
	//
	Vres radius;
	universeClass *univ = amber->getCurrentUniverse();
	radius = univ->getRadius();
	mouse->setLinearScaling(radius * 0.1);

	CView::OnInitialUpdate();
}

void Clesson2View::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	
	// Adjust Amber channel when window size is changed.  Return if
	// channel has not been created or this window is not visible.
	//
	if (!IsWindowVisible() || ch==NULL) return;
	ch->resetPerspective();
}

BOOL Clesson2View::PreCreateWindow(CREATESTRUCT& cs) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	// Set the style of the window to clip children and siblings.  This
	// is a requirement of OpenGL windows.
	//	
	cs.style = cs.style | WS_CLIPSIBLINGS | WS_CLIPCHILDREN;

	return CView::PreCreateWindow(cs);
}
